From c316a598439d2cfabdd7f4d86745fbbe5a17848c Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 30 2020 04:52:45 +0000
Subject: [PATCH 1625/2232] Merge pull request #530 from dtolnay/str-string


Add Str(const String &) noexcept constructor
---

diff --git a/gen/src/builtin.rs b/gen/src/builtin.rs
index 8741e2d..5182e01 100644
--- a/gen/src/builtin.rs
+++ b/gen/src/builtin.rs
@@ -115,6 +115,11 @@ pub(super) fn write(out: &mut OutFile) {
         out.end_block(Block::AnonymousNamespace);
     }
 
+    if builtin.rust_str && !builtin.rust_string {
+        out.next_section();
+        writeln!(out, "class String;");
+    }
+
     ifndef::write(out, builtin.rust_string, "CXXBRIDGE1_RUST_STRING");
     ifndef::write(out, builtin.rust_str, "CXXBRIDGE1_RUST_STR");
     ifndef::write(out, builtin.rust_slice, "CXXBRIDGE1_RUST_SLICE");
diff --git a/include/cxx.h b/include/cxx.h
index fe45121..e40876d 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -73,6 +73,7 @@ private:
 class Str final {
 public:
   Str() noexcept;
+  Str(const String &) noexcept;
   Str(const std::string &);
   Str(const char *);
   Str(const char *, size_t);
diff --git a/src/cxx.cc b/src/cxx.cc
index ef5db8f..c9e2151 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -150,6 +150,8 @@ std::ostream &operator<<(std::ostream &os, const String &s) {
 
 Str::Str() noexcept : ptr(reinterpret_cast<const char *>(1)), len(0) {}
 
+Str::Str(const String &s) noexcept : ptr(s.data()), len(s.length()) {}
+
 static void initStr(const char *ptr, size_t len) {
   if (!cxxbridge1$str$valid(ptr, len)) {
     panic<std::invalid_argument>("data for rust::Str is not utf-8");

